﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Model_Syntakstræ;
using TokenLibrary;
using ParserClassLibrary;

namespace ParserTestConsoleApplication
{
    class Program
    {
        static void Main(string[] args)
        {

            List<Token> tokenliste = getSomeTestTokens();  // skaf testinput

            Parser parser = new Parser(tokenliste);
            if (parser.parseRegionskøreplan())  // husk true hvis det gik godt
            {
                RegionsKøreplan rkp = parser.GetRegionskøreplan();
                rkp.Udskriv();
            }
            else
            {
                Console.WriteLine("Fejlbehæftet regionskøreplan");
                RegionsKøreplan rkp = parser.GetRegionskøreplan();
                rkp.Udskriv();
            }

            Console.ReadLine();
        }

        private static List<Token> getSomeTestTokens()
        {
            List<Token> tokenliste = new List<Token>();
            tokenliste.Add(new Token(Token.Tokentype.Rutenr, "#100", 0));
            tokenliste.Add(new Token(Token.Tokentype.By, "Odense", 0));
            tokenliste.Add(new Token(Token.Tokentype.Tidspunkt, "12:45", 0));
            tokenliste.Add(new Token(Token.Tokentype.By, "Ringe", 0));
            tokenliste.Add(new Token(Token.Tokentype.Tidspunkt, "13:15", 0));
            tokenliste.Add(new Token(Token.Tokentype.By, "Svendborg", 0));
            tokenliste.Add(new Token(Token.Tokentype.Tidspunkt, "13:45", 0));

            //tokenliste.Add(new Token(Token.Tokentype.Fejl, "Et mærkeligt token", 0));

            tokenliste.Add(new Token(Token.Tokentype.Rutenr, "#101", 0));
            tokenliste.Add(new Token(Token.Tokentype.By, "Odense2", 0));
            tokenliste.Add(new Token(Token.Tokentype.Tidspunkt, "14:45", 0));
            tokenliste.Add(new Token(Token.Tokentype.By, "Ringe2", 0));
            tokenliste.Add(new Token(Token.Tokentype.Tidspunkt, "15:15", 0));
            tokenliste.Add(new Token(Token.Tokentype.By, "Svendborg2", 0));
            tokenliste.Add(new Token(Token.Tokentype.Tidspunkt, "15:45", 0));

            tokenliste.Add(new Token(Token.Tokentype.Slut, "", 0));
            return tokenliste;
        }
    }
}
